package org.openxma.dsl.platform.jsf.model;

import java.util.Arrays;
import java.util.Collection;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import javax.faces.model.ListDataModel;

import org.primefaces.model.SelectableDataModel;

public abstract class MapDataModel<K,T> extends ListDataModel<T> implements SelectableDataModel<T> {

	private Map<String, T> modelMap = new HashMap<String, T>();
	private T selectedItem;
	private T[] selectedItems;
	
	public MapDataModel() {
	    super();
	}
	
	@Deprecated
	public MapDataModel(Collection<T> masterList) {
	    super((List<T>) masterList);
	    fillModelMap(masterList);
	}

	@Override
	@Deprecated
	public void setWrappedData(Object masterList) {
	    super.setWrappedData(masterList);
	    fillModelMap((List<T>) masterList);
	}
	
	public void setWrappedData(Collection<T> masterList) {
	    super.setWrappedData(masterList);
	    fillModelMap(masterList);
	}
	

    private void fillModelMap(Collection<T> masterList) {
        modelMap.clear();
        for(T masterObject : masterList) {
        	K key = getRowKey(masterObject);
        	modelMap.put(keyToString(key), masterObject);
        }
    }
    
    /**
     * Default implementation for keyToString
     */
    public String keyToString(K key) {
    	if (key instanceof String)
    		return (String)key; 
    	return String.valueOf(key);
    }

    public T getRowData(String rowKey) {
    	return modelMap.get(rowKey);
    }
    
    public abstract K getRowKey(T object);
    

	public T getSelectedItem() {
		return selectedItem;
	}

	public void setSelectedItem(T selectedItem) {
		this.selectedItem = selectedItem;
	}

	@Deprecated
    public T[] getSelectedItems() {
        return selectedItems;
    }

    public void setSelectedItems(T[] selectedItems) {
        this.selectedItems = selectedItems;
    }
    
    public List<T> getSelectedItemsList() {
    	return Arrays.asList(selectedItems);
    }
    
}

